# Communication

The Kubernetes community abides by the [CNCF code of conduct].  Here is an excerpt:

> _As contributors and maintainers of this project, and in the interest
> of fostering an open and welcoming community, we pledge to respect
> all people who contribute through reporting issues, posting feature
> requests, updating documentation, submitting pull requests or patches,
> and other activities._

## SIGs

Kubernetes encompasses many projects, organized into [SIGs](sig-list.md).
Some communication has moved into SIG-specific channels - see
a given SIG subdirectory for details.

Nevertheless, below find a list of many general channels, groups
and meetings devoted to Kubernetes.

## Social Media

* [Twitter]
* [Google+]
* [blog]
* Pose questions and help answer them on [Slack][slack.k8s.io] or [Stack Overflow].

Most real time discussion happens at [kubernetes.slack.com];
you can sign up at [slack.k8s.io].
 
Discussions on most channels are archived at [kubernetes.slackarchive.io].
Start archiving by inviting the _slackarchive_ bot to a
channel via `/invite @slackarchive`.
To add new channels, contact one of the admins
(briangrant, goltermann, jbeda, sarahnovotny and thockin).

## Issues

If you have a question about Kubernetes or have a problem using it,
please start with the [troubleshooting guide].

If that doesn't answer your questions, or if you think you found a bug,
please [file an issue].


## Mailing lists

Development announcements and discussions appear on the Google group
[kubernetes-dev] (send mail to `kubernetes-dev@googlegroups.com`).

Users trade notes on the Google group
[kubernetes-users] (send mail to `kubernetes-users@googlegroups.com`).


## Weekly Meeting

We have PUBLIC and RECORDED [weekly meeting] every Thursday at 10am US Pacific Time.

Map that to your local time with this [timezone table].

See it on the web at [calendar.google.com], or paste this [iCal url] into any iCal client.

To be added to the calendar items, join the Google group
[kubernetes-community-video-chat] for further instructions.

If you have a topic you'd like to present or would like to see discussed,
please propose a specific date on the [Kubernetes Community Meeting Agenda].


## Conferences

Kubernetes is the main focus of CloudNativeCon/KubeCon, held every spring in Europe and winter in North America. Information about these and other community events is available on the CNCF [events] pages.


[blog]: http://blog.kubernetes.io
[calendar.google.com]: https://calendar.google.com/calendar/embed?src=cgnt364vd8s86hr2phapfjc6uk%40group.calendar.google.com&ctz=America/Los_Angeles
[CNCF code of conduct]: https://github.com/cncf/foundation/blob/master/code-of-conduct.md
[communication]: https://github.com/kubernetes/community/blob/master/communication.md
[community meeting]: https://github.com/kubernetes/community/blob/master/communication.md#weekly-meeting
[events]: https://www.cncf.io/events/
[file an issue]: https://github.com/kubernetes/kubernetes/issues/new
[Google+]: https://plus.google.com/u/0/b/116512812300813784482/116512812300813784482
[iCal url]: https://calendar.google.com/calendar/ical/cgnt364vd8s86hr2phapfjc6uk%40group.calendar.google.com/public/basic.ics
[Kubernetes Community Meeting Agenda]: https://docs.google.com/document/d/1VQDIAB0OqiSjIHI8AWMvSdceWhnz56jNpZrLs6o7NJY/edit#
[kubernetes-community-video-chat]: https://groups.google.com/forum/#!forum/kubernetes-community-video-chat
[kubernetes-dev]: https://groups.google.com/forum/#!forum/kubernetes-dev
[kubernetes-users]: https://groups.google.com/forum/#!forum/kubernetes-users
[kubernetes.slackarchive.io]: http://kubernetes.slackarchive.io
[kubernetes.slack.com]: http://kubernetes.slack.com
[Special Interest Group]: https://github.com/kubernetes/community/blob/master/README.md#SIGs
[slack.k8s.io]: http://slack.k8s.io
[Stack Overflow]: http://stackoverflow.com/questions/tagged/kubernetes
[timezone table]: https://www.google.com/search?q=1000+am+in+pst
[troubleshooting guide]: http://kubernetes.io/docs/troubleshooting
[Twitter]: https://twitter.com/kubernetesio
[weekly meeting]: https://zoom.us/my/kubernetescommunity
