## Kubernetes "User Support" Rotation

### Traffic sources and responsibilities

* [Stack Overflow](http://stackoverflow.com/questions/tagged/kubernetes) and
[ServerFault](http://serverfault.com/questions/tagged/google-kubernetes):
Respond to any thread that has no responses and is more than 6 hours old (over
time we will lengthen this timeout to allow community responses). If you are not
equipped to respond, it is your job to redirect to someone who can.

  * [Query for unanswered Kubernetes Stack Overflow questions](http://stackoverflow.com/search?tab=newest&q=%5bkubernetes%5d%20answers%3a0)
  * [Query for unanswered Kubernetes ServerFault questions](https://serverfault.com/search?tab=newest&q=%5bgoogle-kubernetes%5d%20answers%3a0)
  * Direct poorly formulated questions to [Stack Overflow's tips about how to ask](http://stackoverflow.com/help/how-to-ask)
  * Direct off-topic questions to [Stack Overflow's policy](http://stackoverflow.com/help/on-topic)

* [Slack](https://kubernetes.slack.com) ([registration](http://slack.k8s.io)):
Your job is to be on Slack, watching for questions and answering or redirecting
as needed, such as to a SIG-specific channel. Please especially watch
`#kubernetes-users` and `#kubernetes-novice`. Also check out the
[Slack Archive](http://kubernetes.slackarchive.io/).

* [Email/Groups](https://groups.google.com/forum/#!forum/kubernetes-users):
Respond to any thread that has no responses and is more than 6 hours old (over
time we will lengthen this timeout to allow community responses). If you are not
equipped to respond, it is your job to redirect to someone who can.

*  on slack: Respond to questions that
don't get answers.

In general, try to direct support questions to:

1. Documentation, such as the [user documentation](https://kubernetes.io/docs/) and
[troubleshooting guide](https://kubernetes.io/docs/tasks/debug-application-cluster/troubleshooting/)

2. Stack Overflow

#### User support response example

If you see questions on kubernetes-dev@googlegroups.com, try to redirect them
to Stack Overflow. Example response:

```code
Please re-post your question to [Stack Overflow]
(http://stackoverflow.com/questions/tagged/kubernetes).

We are trying to consolidate the channels to which questions for help/support
are posted so that we can improve our efficiency in responding to your requests,
and to make it easier for you to find answers to frequently asked questions and
how to address common use cases.

We regularly see messages posted in multiple forums, with the full response
thread only in one place or, worse, spread across multiple forums. Also, the
large volume of support issues on github is making it difficult for us to use
issues to identify real bugs.

The Kubernetes team scans Stack Overflow on a regular basis, and will try to
ensure your questions don't go unanswered.

Before posting a new question, please search Stack Overflow for answers to
similar questions, and also familiarize yourself with:

  * [user documentation](http://kubernetes.io/docs/)
  * [troubleshooting guide](https://kubernetes.io/docs/tasks/debug-application-cluster/troubleshooting/)

Again, thanks for using Kubernetes.

The Kubernetes Team
```

If you answer a question (in any of the above forums) that you think might be
useful for someone else in the future, please send a PR or file an issue in
[kubernetes.github.io](https://github.com/kubernetes/kubernetes.github.io).

### Contact information

[@k8s-support-oncall](https://github.com/k8s-support-oncall) will reach the
current person on call.



<!-- BEGIN MUNGE: GENERATED_ANALYTICS -->
[![Analytics](https://kubernetes-site.appspot.com/UA-36037335-10/GitHub/docs/devel/on-call-user-support.md?pixel)]()
<!-- END MUNGE: GENERATED_ANALYTICS -->
