## Kubernetes PM

kubernetes-pm is a github team that will help to manage and maintain the project in ways other than just writing code.  Specifically, members of the kubernetes-pm team are
expected to:

* Add/change routing labels to issues ([sig/, area/](https://github.com/kubernetes/kubernetes/wiki))
* Apply release-note labels to PRs (until that is automated or eliminated)
* Set the milestone on a PR or issue
* Assign issues to the correct people for immediate triage/work
* Assign PRs to be reviewed by the correct people
* Close duplicate, stale, misplaced issues
* Close support issues, with a redirect to Stack Overflow

They should **NOT**:

* Manually apply merge labels to PRs (lgtm, approved) or press merge button
* Apply priority labels to PRs
* Apply cherrypick labels to PRs
* Edit text of other people's PRs and issues, including deleting comments
* Modify anyone else's release note
* Create, edit, delete labels
* Create, edit, close, delete milestones
* Create, edit, delete releases
* Create, edit, delete PR statuses
* Edit wiki

Abuse and misuse will result in prompt removal from the Project Managers group and loss of privileges.

## Joining the group

The following is the provisional process for adding people to the group:

1. Join kubernetes-wg-contribex at googlegroups.com. Send a message to that group that states:
1. Your github id.
1. What you are working on with respect to the project.
1. Any official management or leadership responsibilities you may have (e.g., manager of a team that includes the following contributors: ….).
1. What you plan to do with the powers, including specific labels, SIGs, system components, github teams, etc.
1. How long you think you need the powers.
1. Any questions you have about appropriate application of the powers (e.g., policy for assigning priorities to issues, policy for assigning and unassigning issues, which parts of the system are covered by which teams).


The Contributor Experience working-group leads or Brian Grant (@bgrant0607) will approve or deny your request.

Some prerequisites may need to be completed prior to being added to the github team, such as clarifying relevant policies in our contributor documentation.

Thanks for helping to manage the project!
